<template>
    <div>
        <div class="content-block">
            <div class="container">
                <div class="margin-top-50"></div>
                <div class="row">
                    <div class="columns twelve central-column pos-block">
                        <div class="content">
                            <div class="row header-block">
                                <div class="column">
                                    <h3>График платежей</h3>
                                </div>
                            </div>
                            <div class="pos-pay-graph" v-if="$installment.schedule.length">
                                <div class="white-block">
                                    <div class="padding adaptive-hidden">
                                        <div class="row table-header">
                                            <div class="columns five" >Сумма</div>
                                            <div class="columns seven">Рекомендуемая дата</div>
                                        </div>
                                    </div>
                                    <div class="question-block q-blue q-big">
                                        <div class="question padding" @click="displayDetails = !displayDetails">
                                            <div class="row">
                                                <div class="columns five">
                                                    <span class="adaptive-show">Необходимо внести</span>
                                                    <strong>{{currentPay.amount}} &#8381;</strong>
                                                </div>
                                                <div class="columns seven">
                                                    До <strong>{{$dayjs(currentPay.date).format('DD.MM.YYYY')}}</strong>
                                                </div>
                                            </div>
                                            <img src="/lk/static/img/pos/arrow.png"
                                                 alt=""
                                                 class="faq-arrow"
                                                 :class="{expand:displayDetails}"/>
                                        </div>
                                        <transition name="fade">
                                            <payment-details :item="currentPay" v-if="displayDetails"></payment-details>
                                        </transition>
                                    </div>

                                    <div class="padding">
                                        <payment-block v-model="sum" :history="true"/>
                                    </div>


                                    <hr>
                                    <div class="padding">
                                        <h3 class="bold-header">График платежей:</h3>
                                    </div>
                                    <hr/>
                                    <div v-for="schedule in $installment.schedule.slice(1)"
                                         :key="schedule.id"
                                            class="question-block q-white q-big">
                                        <div class="question padding" @click="setDisplayDetails(schedule.date)">
                                            <div class="row">
                                                <div class="columns five">До {{$dayjs(schedule.date).format('DD.MM.YYYY')}}</div>
                                                <div class="columns seven">{{schedule.amount}} &#8381;</div>
                                            </div>
                                            <img src="/lk/static/img/pos/arrow.png"
                                                 alt=""
                                                 :class="{expand: displayDetailsHistory[schedule.date]}"
                                                 class="faq-arrow" />
                                        </div>
                                        <transition name="fade">
                                            <payment-details
                                                    :item="schedule"
                                                    v-if="displayDetailsHistory[schedule.date]"
                                                    history>
                                            </payment-details>
                                        </transition>
                                    </div>


                                </div>
                            </div>
                            <div class="white-block padding " v-else>
                                <div class="question-block q-blue q-default">
                                    <div class="question padding operations-tape-empty-info">
                                        Список платежей отсутствует.
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="clear-fix-block"></div>
    </div>
</template>

<script>
    import paymentDetails from './Components/Schedule/PaymentDetails'
    import paymentBlock from './Components/PaymentBlock/index.vue';

  export default {
    name: 'installmentSchedule',
    components: {
      paymentDetails,
      paymentBlock
    },
    data() {
      return {
        displayDetails: false,
        sum: 0,
        displayDetailsHistory: {},
        history: [],
      }
    },

    computed: {
      currentPay () {
        const current = this.$dayjs().format('YYYY-MM')
        return this.$installment.schedule.find((s) => {
          return s.date.startsWith(current)
        }) || this.$installment.schedule[0];
      },

      paymentAmount: {
        get () {
          return this.sum;
        },

        set (v) {
          this.sum = v;
        }
      },
    },

    watch: {
      currentPay: {
        deep: true,
        /**
         * @param {INSTALLMENT_SCHEDULE} pay
         */
        handler (pay) {
            this.sum = 0;
            pay.sales.forEach(( s) => {
              if(s.selected) {
                this.sum += s.amount;
              }
            })
        }
      }
    },

    created () {
      this.AJAX_LOADING(true);
      this.$store.dispatch('GET_INSTALLMENT_DATA').then(() => {
        this.sum = 0;
        this.currentPay.sales.forEach(( s) => {
          if(s.selected) {
            this.sum += s.amount;
          }
        });
      }).catch((e) => {

      }).finally(() => {
        this.AJAX_LOADING(false);
      });


    },

    methods: {
      setDisplayDetails (id) {
        console.log(this.displayDetailsHistory);
        if (this.displayDetailsHistory[id]) {
          this.$delete(this.displayDetailsHistory, id);
        } else {
          this.$set(this.displayDetailsHistory, id, true);
        }
      }
    }
  }
</script>

<style scoped lang="scss">

    .faq-arrow {
        transition-duration: 0.3s;
        & .active {
            transition-duration: 0.3s;
            transform: rotate(180deg) ;
        }
    }


</style>
